
import 'dart:async';

import 'package:flutter/services.dart';
import 'package:rxdart/rxdart.dart';
import 'dart:convert';


class MihService {
  static const MethodChannel _channel =
      const MethodChannel('mih_service');


  static const EventChannel _channelEvent = const EventChannel('plugins.flutter.io/mihi/location');
  static BehaviorSubject<Map<String, dynamic>> _locationController = BehaviorSubject<Map<String, dynamic>>();
  static Stream<Map<String, dynamic>> get locationStream => _locationController.stream;
//
  static StreamSubscription _streamSubscription;

  static  void enableEventReceiver() {
    _streamSubscription = _channelEvent.receiveBroadcastStream().listen(
            (dynamic event) {
          print('Received event: $event');
          //String str = json.encode(event);
          Map valueMap = jsonDecode(event);
         // Map eventMap = json.decode(str);
          /*Map map = Map<String, String>();
          map =  {
            'lat': event['lAT'] as String,
            'lng': event['lNG'] as String,
            'distance': event['DISTANCE'] as String};*/
          _locationController.add(valueMap);
        },
        onError: (dynamic error) {
          print('Received error: ${error.message}');
        },
        cancelOnError: true);
  }

  static void _disableEventReceiver() {
    if (_streamSubscription != null) {
      _streamSubscription.cancel();
      _streamSubscription = null;
    }
  }


  static Future<String>  startService (var tripId,var startTimestamp) async {
    final String version =await _channel.invokeMethod("startService", <String, dynamic>{
      'tripId':tripId,
      'startTimestamp':startTimestamp,
      'holdWakeLock': false,
      'icon': "ic_stat_hot_tub",
      'color': 0,
      'title': "title",
      'content': "content",
      'subtext': "subtext",
      'chronometer': false,
      'stop_action': false,
      'stop_icon': "ic_stat_hot_tub",
      'stop_text': "stopText",
    });


    //_channel.setMethodCallHandler(_handleMethod);
    return version;
  }

  static Future<String> get stopService async {
    print("onStartStopService");
    final String version =await _channel.invokeMethod("stopService", <String, dynamic>{});
    return version;
  }

  static Future<String> get bindService async {
    print("onStartBindService");
    final String version =await _channel.invokeMethod("bindService", <String, dynamic>{});
    return version;
  }

  static Future<String> get currentLocation async {
    print("getCurrentLocation");
    final String currentLocation =await _channel.invokeMethod("currentLocation", <String, dynamic>{});
    print("currentLocation =$currentLocation");
    return currentLocation;
  }

  Future<dynamic> _handleMethod(MethodCall call) async {
    switch (call.method) {
      case "getPlatformVersion":
      //debugPrint(call.arguments);
        return new Future.value("");
    }
  }


}
